#include "stdafx.h"
#include "PIdl.h"

//pidl :  ۿ  ItemIDList 
//pStr : IShellFolder::GetDisplayNameOf() Լ ؼ ȹ STRRET 
//Return Value : ڿ (pszBuf)
void StrretToString(LPITEMIDLIST pidl, LPSTRRET pStr, LPSTR pszBuf)
{
   lstrcpy(pszBuf, "");

   switch(pStr->uType)
   {
   case STRRET_WSTR:              // Unicode string
      WideCharToMultiByte(CP_ACP, 0, pStr->pOleStr, -1, pszBuf, MAX_PATH, NULL, NULL);
      break;

   case STRRET_OFFSET:            // Offset
      lstrcpy(pszBuf, reinterpret_cast<LPSTR>(pidl) + pStr->uOffset);
      break;

   case STRRET_CSTR:              // ANSI string
      lstrcpy(pszBuf, pStr->cStr);
      break;
   }
}

//Return Value :
//ڷ Ѿ dwData  ˻ pszItem    
//pIdl CallBack Լ  ϱ ؼ  ȿ̴.
BOOL CALLBACK SearchText(LPCSTR pszItem, LPITEMIDLIST pIdl, DWORD dwData)
{
   return static_cast<BOOL>(lstrcmpi(pszItem, reinterpret_cast<LPCSTR>(dwData)));
}

//Return Value :
//ڷ Ѿ dwData  ˻ pszItem    
//pIdl CallBack Լ  ϱ ؼ  ȿ̴.
BOOL CALLBACK SearchPidl(LPCSTR pszItem, LPITEMIDLIST pIdl, DWORD dwData)
{
	LPITEMIDLIST PIDL = reinterpret_cast<LPITEMIDLIST>(dwData);
	return (pIdl == PIDL) ? 0:1;
}

/////////////////////////////////////////////
// SHEnumFolderContent
// pFolder : Ʈ 
// pfn     : User Defined CallBack Function
// dwData  : ܺο Ѿ   - CallBack Լ ϴ 
// ppidl   : ãƳ LPITEMIDLIST
// Return Value : ش  ο ϴ   Ȥ ã  
int SHEnumFolderContent(LPSHELLFOLDER pFolder, FOLDERCONTENTPROC pfn, 
						DWORD dwData, LPITEMIDLIST* ppidl)
{
   int iNumOfItems = 0;

   // Enumerates the content
   LPENUMIDLIST pEnumIDList = NULL;
   pFolder->EnumObjects(NULL, SHCONTF_FOLDERS | SHCONTF_NONFOLDERS, &pEnumIDList);

   ULONG ulFetched = 0;
   LPITEMIDLIST pItem = NULL;
   while(NOERROR == pEnumIDList->Next(1, &pItem, &ulFetched))
   {
      STRRET sName;
      TCHAR szBuf[MAX_PATH] = {0};
      pFolder->GetDisplayNameOf(pItem, 0, &sName);
      StrretToString(pItem, &sName, szBuf);

      // Invoke callback
      if(pfn)
      {
         if(!pfn(szBuf, pItem, dwData))
         {
            // Returns the current PIDL
            if(ppidl != NULL)
               *ppidl = pItem;
            break;
         }
      }
      ++iNumOfItems;
   }
   return iNumOfItems;
}

//////////////////////////////////////////////////////////
// SHPathToPidlEx
// szPath : Full Path Name
// ppidl  : ãƳ ITEMIDLIST
// pFolder : Ʈ  .. NULL̸ ũ ž .
HRESULT SHPathToPidlEx(LPCTSTR szPath, LPITEMIDLIST* ppidl, LPSHELLFOLDER pFolder)
{
   OLECHAR wszPath[MAX_PATH] = {0};
   ULONG nCharsParsed = 0;
   LPSHELLFOLDER pShellFolder = NULL;
   BOOL bFreeOnExit = FALSE;

   MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, szPath, -1, wszPath, MAX_PATH);

   // Use the desktop's IShellFolder by default
   if(pFolder == NULL)
   {
      SHGetDesktopFolder(&pShellFolder);
      bFreeOnExit = TRUE;
   } 
   else
      pShellFolder = pFolder;

   HRESULT hr = pShellFolder->ParseDisplayName(NULL, NULL, wszPath, &nCharsParsed, ppidl, NULL);

   if(bFreeOnExit)
      pShellFolder->Release();

   return hr;
}

//////////////////////////////////////////////////////////////////
// ־ ڿ  SHELLFOLDER ȯѴ.
void StrToFolder(TCHAR szName[MAX_PATH], LPSHELLFOLDER& pSubFolder)
{
	LPITEMIDLIST pidl = NULL;
	LPSHELLFOLDER pFolder = NULL;

	// Get the memory allocator
	LPMALLOC pMalloc = NULL;
	SHGetMalloc(&pMalloc);

	// Get the IShellFolder interface for the desktop
	SHGetDesktopFolder(&pFolder);

	// ũ ž    ȹѴ.
	int iNumOfItems = SHEnumFolderContent(pFolder, NULL, 0, NULL);
	// Try to find a match under Desktop
	int rc = SHEnumFolderContent(pFolder, 
				SearchText, //CallBack Function
				reinterpret_cast<DWORD>(szName), &pidl);

	// If not found, try under My Computer
	if(rc == iNumOfItems)
	{
	  // Bind to My Computer
	  LPITEMIDLIST pidlMyComp;
	  SHGetSpecialFolderLocation(NULL, CSIDL_DRIVES, &pidlMyComp);
	  pFolder->BindToObject(pidlMyComp, NULL, IID_IShellFolder,
							   reinterpret_cast<LPVOID*>(&pSubFolder));

	  // Free the pointer to the desktop folder
	  pFolder->Release();
	  pMalloc->Free(pidlMyComp);
	  pFolder = pSubFolder;

	  // Scan My Computer
	  iNumOfItems = SHEnumFolderContent(pFolder, NULL, 0, NULL);
	  rc = SHEnumFolderContent(pFolder, 
				SearchText, //CallBack Function
				reinterpret_cast<DWORD>(szName), &pidl);

	  if(rc == iNumOfItems)
	  {
		 // Make the last attempt: is it a path name?
		 HRESULT hr = SHPathToPidlEx(szName, &pidl, pFolder); //Local Function
		 if(FAILED(hr)) {
			pMalloc->Free(pidl);
			pFolder->Release();
			pSubFolder = NULL;
			return;
		 }
	  }
	}

	// If here, then:
	//   pidl points to the folder we need to bind to enumerate the content
	//   pFolder points to the IShellFolder of the pidl's parent folder

	// Bind to the subfolder we're searching for
	// pFolder can point to Desktop's or My Computer's IShellFolder
	pFolder->BindToObject(pidl, NULL, IID_IShellFolder,
								   reinterpret_cast<LPVOID*>(&pSubFolder));

	// Clean up
	pFolder->Release();
	pMalloc->Free(pidl);
	pMalloc->Release();
}

//////////////////////////////////////////////////////////////////
// ־ ITEMIDLIST  SHELLFOLDER ȯѴ.
void PIdlToFolder(LPITEMIDLIST PIDL, LPSHELLFOLDER& pSubFolder)
{
	LPITEMIDLIST pidl = NULL;
	LPSHELLFOLDER pFolder = NULL;

	// Get the memory allocator
	LPMALLOC pMalloc = NULL;
	SHGetMalloc(&pMalloc);

	// Get the IShellFolder interface for the desktop
	SHGetDesktopFolder(&pFolder);

	// ũ ž    ȹѴ.
	int iNumOfItems = SHEnumFolderContent(pFolder, NULL, 0, NULL);
	// Try to find a match under Desktop
	int rc = SHEnumFolderContent(pFolder, 
				SearchPidl, //CallBack Function
				reinterpret_cast<DWORD>(PIDL), &pidl);

	// If not found, try under My Computer
	if(rc == iNumOfItems)
	{
	  // Bind to My Computer
	  LPITEMIDLIST pidlMyComp;
	  SHGetSpecialFolderLocation(NULL, CSIDL_DRIVES, &pidlMyComp);
	  pFolder->BindToObject(pidlMyComp, NULL, IID_IShellFolder,
							   reinterpret_cast<LPVOID*>(&pSubFolder));

	  // Free the pointer to the desktop folder
	  pFolder->Release();
	  pMalloc->Free(pidlMyComp);
	  pFolder = pSubFolder;

	  // Scan My Computer
	  iNumOfItems = SHEnumFolderContent(pFolder, NULL, 0, NULL);
	  rc = SHEnumFolderContent(pFolder, 
				SearchPidl, //CallBack Function
				reinterpret_cast<DWORD>(PIDL), &pidl);

	  if(rc != iNumOfItems)
	  {
		pMalloc->Free(pidl);
		pFolder->Release();
		pSubFolder = NULL;
		return;
	  }
	}

	// If here, then:
	//   pidl points to the folder we need to bind to enumerate the content
	//   pFolder points to the IShellFolder of the pidl's parent folder

	// Bind to the subfolder we're searching for
	// pFolder can point to Desktop's or My Computer's IShellFolder
	pFolder->BindToObject(pidl, NULL, IID_IShellFolder,
								   reinterpret_cast<LPVOID*>(&pSubFolder));

	// Clean up
	pFolder->Release();
	pMalloc->Free(pidl);
	pMalloc->Release();
}